/**
 * Created by Audy on 21-Mar-16.
 */
app.controller("ChangePasswordCtrl", function ($scope,
                                               $http,
                                               httpService,
                                               $stateParams,
                                               $ionicPlatform,
                                               $ionicPopup,
                                               $ionicLoading) {

    $scope.title = "Change Password";
    $scope.button_text_change_password = "Change Password";
    
    menu_text_change_password = default_menu_titles.change_password !== undefined && default_menu_titles.change_password[language]!==undefined ? default_menu_titles.change_password[language] : "Change Password";
    $scope.title = menu_text_change_password;
    $scope.button_text_change_password = menu_text_change_password;
    
    $scope.input = {
        old_password: '',
        confirm_password: '',
        new_password: ''
    };

    $scope.changePassword = function()
    {
        // get data
        $scope.show();
        var obj = serializeData({user_id:user_id, old_password: $scope.input.old_password, new_password: $scope.input.new_password, confirm_password: $scope.input.confirm_password});

        httpService.post($scope, $http, change_password_url, obj);
    };

    // get data success
    $scope.$on('httpService:postRequestSuccess', function () {
        $scope.hide();
        //console.log($scope.data);
        if($scope.data.success === true)
        {
            $scope.showChangePasswordSuccessAlert();
        }
        else
        {
            $scope.showWrongOldPasswordFailedAlert();
        }

    });

    // if get token detail data Error, request token again
    $scope.$on('httpService:postTokenError', function () {

        var url = token_url;
        var obj = serializeData({email: username, password: password, company_id: company_id});
        httpService.post_token($scope, $http, url, obj, 'content');

    });

    // if get detail data Error, request token again
    $scope.$on('httpService:postRequestError', function () {
        $scope.showChangePasswordFailedAlert();

    });

    $scope.show = function () {
        $ionicLoading.show({
            template: ionicLoadingTemplate
        });
    };

    $scope.hide = function () {
        $ionicLoading.hide();
    };

    $scope.showChangePasswordSuccessAlert = function (username) {
        var alertPopup = $ionicPopup.alert({
            title: 'Change Password',
            template: '<div style="width:100%;text-align:center">Change Password Success</div>'
        });
    };

    $scope.showWrongOldPasswordFailedAlert = function () {
        var alertPopup = $ionicPopup.alert({
            title: 'Change Password',
            template: '<div style="width:100%;text-align:center">Old Password did not match with our record</div>'
        });
    };

    $scope.showChangePasswordFailedAlert = function (username) {
        var alertPopup = $ionicPopup.alert({
            title: 'Change Password',
            template: '<div style="width:100%;text-align:center">Failed to change password. Please check Your Internet Connection and Try Again</div>'
        });
    };

});

