app.controller("LoginCtrl", function ($scope,
                                      $rootScope,
                                      $http,
                                      httpService,
                                      $cordovaDevice,
                                      $ionicLoading,
                                      $ionicPopup,
                                      $ionicHistory,
                                      $ionicPlatform,
                                      $state) {

    var login_redirect_location = '';
    
    $ionicPlatform.ready(function () {
        $scope.result = '';
        $scope.button_text_login = "Log In";
        $scope.button_text_register = "Register";
        $scope.button_text_logout = "Logout";
        $scope.button_text_edit_profile = "Edit Profile";
        $scope.button_text_change_password = "Change Password";
        $scope.button_text_top_up = "Top Up";
        $scope.ui_text_or = "or";
        $scope.ui_text_forgot_password = "Forgot Password?";
        $scope.ui_text_click_here = "Click Here";
        $scope.summernote_text_login_instruction = "";
        
//        menu_text_login = default_menu_titles.login !== undefined && default_menu_titles.login[language]!==undefined ? default_menu_titles.login[language] : "Login";
        $scope.button_text_login = ui_texts_login.button_text_login !== undefined && ui_texts_login.button_text_login[language] !== undefined ? ui_texts_login.button_text_login[language] : $scope.button_text_login;//menu_text_login;
        
        menu_text_register = default_menu_titles.register !== undefined && default_menu_titles.register[language]!==undefined ? default_menu_titles.register[language] : "Register";
        $scope.button_text_register = menu_text_register;
        
        menu_text_ui_text_or = default_menu_titles.ui_text_or !== undefined && default_menu_titles.ui_text_or[language]!==undefined ? default_menu_titles.ui_text_or[language] : "or";
        $scope.ui_text_or = menu_text_ui_text_or;
        
        menu_text_ui_text_forgot_password = default_menu_titles.ui_text_forgot_password !== undefined && default_menu_titles.ui_text_forgot_password[language]!==undefined ? default_menu_titles.ui_text_forgot_password[language] : "Forgot Password?";
        $scope.ui_text_forgot_password = menu_text_ui_text_forgot_password;
        
        menu_text_ui_text_click_here = default_menu_titles.ui_text_click_here !== undefined && default_menu_titles.ui_text_click_here[language]!==undefined ? default_menu_titles.ui_text_click_here[language] : "Click Here";
        $scope.ui_text_click_here = menu_text_ui_text_click_here;
        
        menu_text_logout = default_menu_titles.logout !== undefined && default_menu_titles.logout[language]!==undefined ? default_menu_titles.logout[language] : "Logout";
        $scope.button_text_logout = menu_text_logout;
        
        menu_text_edit_profile = default_menu_titles.edit_profile !== undefined && default_menu_titles.edit_profile[language]!==undefined ? default_menu_titles.edit_profile[language] : "Edit Profile";
        $scope.button_text_edit_profile = menu_text_edit_profile;
        
        menu_text_change_password = default_menu_titles.change_password !== undefined && default_menu_titles.change_password[language]!==undefined ? default_menu_titles.change_password[language] : "Change Password";
        $scope.button_text_change_password = menu_text_change_password;
        
        menu_text_top_up = default_menu_titles.top_up !== undefined && default_menu_titles.top_up[language]!==undefined ? default_menu_titles.top_up[language] : "Top Up";
        $scope.button_text_top_up = menu_text_top_up;
        
        $scope.summernote_text_login_instruction =  ui_texts_login.summernote_text_login_instruction !== undefined && ui_texts_login.summernote_text_login_instruction[language]!==undefined ? ui_texts_login.summernote_text_login_instruction[language] : $scope.summernote_text_login_instruction;
        
        
        // initialize user login data, set '' for deployment
        $scope.input = {
            email: '',
            password: ''
        };

        $scope.username_login = username_login;

        if (user_id === '') {
            $scope.isLogin = false;
        } else {
            $scope.isLogin = true;
        }

        $scope.title = login_menu;
        //$scope.inAppPurchaseEnabled = inAppPurchaseEnabled;
        $scope.is_membership_enabled = is_membership_enabled;
        $scope.shopping_enabled = shopping_enabled ? 'YES':'NO';
            
        if($rootScope.login_redirect_location!=undefined && $rootScope.login_redirect_location!='')
        { 
            login_redirect_location = $rootScope.login_redirect_location;
            $rootScope.login_redirect_location='';
        }

    });

    $scope.save_login_redirect = function(){
        $rootScope.login_redirect_location = login_redirect_location;
    }
    
    // function for login
    $scope.login = function () {

        if ($scope.input.email !== '' && $scope.input.password !== '') {
            $scope.show();

            var url = login_url;
            var input = $scope.input;
            var device_id = '';
            if (isPhoneGap()) {
                device_id = $cordovaDevice.getDevice().uuid;
            }
            console.log(input);
            var obj = serializeData({
                email: input.email,
                password: input.password,
                company_id: company_id,
                device_id: device_id
            });

            httpService.post($scope, $http, url, obj);
        } else {
            $scope.showRequirementAlert();
        }

    };

    // if post login data success
    $scope.$on('httpService:postRequestSuccess', function () {
        $scope.result = $scope.data;
        $scope.hide();

        if ($scope.result.message == null || $scope.result.message == '' || $scope.result.message == undefined) {
            $scope.showFailedAlert();
        }

        // if user authentication success
        if ($scope.result.success === true) {
            var temp_user_meta = $scope.result['user']['company_user_meta'];
            for(var i=0; i<temp_user_meta.length; i++)
            {
                var key = temp_user_meta[i]['key'];
                var value = temp_user_meta[i]['value'];
                if (key.indexOf('_date') !== -1) {
                    value = new Date(value);
                }
                user_meta[key] = value;
            }

            if (isPhoneGap()) {
                // save user login to database
                //console.log(db);
                if (db === '') {
                    db = window.sqlitePlugin.openDatabase({name: sqlitedb, location: 'default'});
                }

                db.transaction(function (tx) {
                    //console.log($scope.result.user.id + ' ' + $scope.result.user.username);
                    tx.executeSql('CREATE TABLE IF NOT EXISTS ' + user_table + ' (id integer primary key, user text)');
                    tx.executeSql('DELETE FROM ' + user_table);
                    tx.executeSql("INSERT INTO " + user_table + " (id, user) VALUES (?,?)", [$scope.result.user.id, JSON.stringify($scope.result.user)], function (tx, res) {
                        //console.log("insertId: " + res.insertId + " -- probably 1");
                        //console.log("rowsAffected: " + res.rowsAffected + " -- should be 1");

                        $scope.showAlert('Login', $scope.result.message);
                        user_id = $scope.result.user.id;
                        username_login = $scope.result.user.username;
                        email = $scope.result.user.email;

                        if (getPostMetaValueById($scope.result.user.company_user_meta, 'address') != null && getPostMetaValueById($scope.result.user.company_user_meta, 'address') != undefined) {
                            address = getPostMetaValueById($scope.result.user.company_user_meta, 'address').value;
                        }

                        if (getPostMetaValueById($scope.result.user.company_user_meta, 'phone') != null && getPostMetaValueById($scope.result.user.company_user_meta, 'phone') != undefined) {
                            phone = getPostMetaValueById($scope.result.user.company_user_meta, 'phone').value;
                        }

                        //console.log(username_login + ' ' + user_id + ' ' + email + ' ' + phone);
                        
                        menu_text_user = default_menu_titles.user !== undefined && default_menu_titles.user[language]!==undefined ? default_menu_titles.user[language] : "User";
                        
                        login_menu = menu_text_user;

                        $scope.title = login_menu;

                        //console.log(main_menu[main_menu.length - 3]);
                        var idx = main_menu.findIndex(checkTemplate);
                        main_menu[idx].title = login_menu;
                        // main_menu[main_menu.length - 4].title = login_menu;

                        $scope.username_login = username_login;
                        $scope.isLogin = true;
                        $rootScope.isLoggedIn = true;
                        main_menu['transaction_list'] = $scope.isLogin;
                        $rootScope.transaction_count = $scope.result['transaction_count'];
                        
                        $rootScope.user_id = user_id;
                        $scope.refreshMenu();
                    }, function (e) {
                        console.log("ERROR: " + e.message);
                        $scope.isLogin = false;
                        main_menu['transaction_list'] = $scope.isLogin;
                        $rootScope.transaction_count = $scope.result['transaction_count'];
                        $scope.showAlert('Login', "Login Error. Please Try Again");
                    });
                });
            }
            else {
                $scope.showAlert('Login', $scope.result.message);
                user_id = $scope.result.user.id;
                username_login = $scope.result.user.username;
                email = $scope.result.user.email;

                if (getPostMetaValueById($scope.result.user.company_user_meta, 'address') != null && getPostMetaValueById($scope.result.user.company_user_meta, 'address') != undefined) {
                    address = getPostMetaValueById($scope.result.user.company_user_meta, 'address').value;
                }

                if (getPostMetaValueById($scope.result.user.company_user_meta, 'phone') != null && getPostMetaValueById($scope.result.user.company_user_meta, 'phone') != undefined) {
                    phone = getPostMetaValueById($scope.result.user.company_user_meta, 'phone').value;
                }
                //console.log(username_login + ' ' + user_id + ' ' + email + ' ' + phone + ' ' + address);
                menu_text_user = default_menu_titles.user !== undefined && default_menu_titles.user[language]!==undefined ? default_menu_titles.user[language] : "User";
                        console.log(default_menu_titles);
                login_menu = menu_text_user;
                
                $scope.title = login_menu;

                //console.log(main_menu[main_menu.length - 3]);
                var idx = main_menu.findIndex(checkTemplate);
                main_menu[idx].title = login_menu;

                // main_menu[main_menu.length - 4].title = login_menu;

                $scope.username_login = username_login;
                $scope.isLogin = true;
                $rootScope.isLoggedIn = true;
                main_menu['transaction_list'] = $scope.isLogin;
                $rootScope.transaction_count = $scope.result['transaction_count'];
//                console.log("UPDATED");
//                console.log("ROOT SCOPE UPDATE" + $rootScope.transaction_count);
//                console.log($rootScope.transaction_count);
                
                $rootScope.user_id = user_id;
                $scope.refreshMenu();
            }
            
            if(login_redirect_location!=undefined && login_redirect_location!='')
            { 
                window.location.href = login_redirect_location;
                login_redirect_location = '';
            }
        }
        else {
            //if expired and needs top-up
            if($scope.result.status_code === 'expired' && is_membership_enabled=='YES')
            {
                $scope.showAlert('Login', $scope.result.message);
                user_id = $scope.result.user.id;
                username_login = $scope.result.user.username;
                email = $scope.result.user.email;

                if(getPostMetaValueById($scope.result.user.company_user_meta, 'address') != null && getPostMetaValueById($scope.result.user.company_user_meta, 'address') != undefined)
                {
                    address = getPostMetaValueById($scope.result.user.company_user_meta, 'address').value;
                }

                if(getPostMetaValueById($scope.result.user.company_user_meta, 'phone') != null && getPostMetaValueById($scope.result.user.company_user_meta, 'phone') != undefined)
                {
                    phone = getPostMetaValueById($scope.result.user.company_user_meta, 'phone').value;
                }
                console.log(username_login + ' ' + user_id + ' ' + email + ' ' + phone + ' ' + address);
                
                menu_text_user = default_menu_titles.user !== undefined && default_menu_titles.user[language]!==undefined ? default_menu_titles.user[language] : "User";
                        
                login_menu = menu_text_user;
                
                $scope.title = login_menu;
                $scope.username_login = username_login;

                window.location.href = "#/app/top-up/-6";
            }
            else
            {
                $scope.isLogin = false;
                $rootScope.isLoggedIn = false;
                main_menu['transaction_list'] = $scope.isLogin;
                $rootScope.transaction_count = $scope.result['transaction_count'];
                $scope.showAlert('Login', $scope.result.message);
            }
        }

    });

    // logout function
    $scope.showLogoutConfirm = function () {
        var confirmPopup = $ionicPopup.confirm({
            title: 'Logout',
            template: 'Are you sure you want to logout?',
            okType:'cp-button'
        });

        //confirmation dialog
        confirmPopup.then(function (res) {
            if (res) {
                var device_id = '';
                if (isPhoneGap()) {
                    device_id = $cordovaDevice.getDevice().uuid;
                }
                //device_id = '2c5652e569bba77f'; // Testing Purposes Only
                var url = logout_url + '?user_id=' + user_id + '&company_id=' + company_id + '&device_id=' + device_id ;
                httpService.get($scope, $http, url, 'logout');
                
                $rootScope.user_id = '';
                $scope.refreshMenu();

                if (isPhoneGap()) {
                    //console.log(db);
                    if (db === '') {
                        db = window.sqlitePlugin.openDatabase({name: sqlitedb, location: 'default'});
                    }
                    db.transaction(function (tx) {
                        //tx.executeSql('DROP TABLE IF EXISTS ' + user_table);
                        //console.log(user_id + " " + username_login);
                        tx.executeSql("DELETE FROM " + user_table, [], function (tx, res) {
                            //apus dari db
                            user_id = '';
                            username_login = '';
                            email = '';
                            phone = '';
                            address = '';

                            $scope.isLogin = false;
                            $rootScope.isLoggedIn = false;
                            main_menu['transaction_list'] = $scope.isLogin;
                            $rootScope.transaction_count = $scope.result['transaction_count'];
                            
//                            menu_text_login = default_menu_titles.login !== undefined && default_menu_titles.login[language]!==undefined ? default_menu_titles.login[language] : "Login";
//                            $scope.button_text_login = "Login";//menu_text_login;
        
                            login_menu = menu_text_login;
                            $scope.title = login_menu;

                            var idx = main_menu.findIndex(checkTemplate);
                            main_menu[idx].title = login_menu;
//                            console.log("*** Login MENU: " + $scope.title + "***");
                            // main_menu[main_menu.length - 4].title = login_menu;
                            $scope.showAlert('Logout', "Logout Success");

                            $ionicHistory.nextViewOptions({
                                disableBack: true
                            });
                            $ionicHistory.clearHistory();

                            if (login_required == true) {
                                login_menu = 'User';
                                var idx = main_menu.findIndex(checkTemplate);
                                main_menu[idx].title = login_menu;
                                // main_menu[main_menu.length - 4].title = login_menu;
                                $state.go("login");
                                $ionicHistory.clearHistory();
                            } else {
                                $state.go('app.' + home_template, {id: home_id});
                                $ionicHistory.clearHistory();
                            }

                        }, function (e) {
                            console.log("ERROR: " + e.message);
                            $scope.isLogin = true;
                            $rootScope.isLoggedIn = true;
                            main_menu['transaction_list'] = $scope.isLogin;
                            $rootScope.transaction_count = $scope.result['transaction_count'];
                            $scope.showAlert('Logout', "Logout Failed. Please Try Again");
                        });
                    });
                }
                else {

                    user_id = '';
                    username_login = '';
                    email = '';
                    phone = '';
                    address = '';

                    $scope.isLogin = false;
                    $rootScope.isLoggedIn = false;
                    main_menu['transaction_list'] = $scope.isLogin;
                    $rootScope.transaction_count = $scope.result['transaction_count'];
                    
//                    menu_text_login = default_menu_titles.login !== undefined && default_menu_titles.login[language]!==undefined ? default_menu_titles.login[language] : "Login";
//                    $scope.button_text_login = "Login";//menu_text_login;
                    
                    login_menu = menu_text_login;
                    $scope.title = login_menu;
                    console.log("*** Login MENU: " + $scope.title + "***");
                    // console.log(main_menu[main_menu.length - 3]);
                    var idx = main_menu.findIndex(checkTemplate);
                    main_menu[idx].title = login_menu;
                    // main_menu[main_menu.length - 4].title = login_menu;

                    $scope.showAlert('Logout', "Logout Success");

                    $ionicHistory.nextViewOptions({
                        disableBack: true
                    });
                    $ionicHistory.clearHistory();

                    if (login_required == true) {
                        login_menu = 'User';
                        var idx = main_menu.findIndex(checkTemplate);
                        main_menu[idx].title = login_menu;
                        // main_menu[main_menu.length - 4].title = login_menu;
                        $state.go("login");
                        $ionicHistory.clearHistory();
                    } else {
                        $state.go('app.' + home_template, {id: home_id});
                        $ionicHistory.clearHistory();
                    }
                }
            }
            else {
                $scope.isLogin = true;
                $rootScope.isLoggedIn = true;
                main_menu['transaction_list'] = $scope.isLogin;
                $rootScope.transaction_count = $scope.result['transaction_count'];
            }
        });
    };

    $scope.$on('httpService:postRequestError', function () {
        $scope.hide();
        $scope.showFailedAlert();

    });

    $scope.showAlert = function (title, message) {
        var alertPopup = $ionicPopup.alert({
            title: title,
            css: 'cp-button',
            template: '<div style="width:100%;text-align:center">' + message + '</div>',
            okType: 'cp-button'
        });
    };

    $scope.show = function () {
        $ionicLoading.show({
            template: ionicLoadingTemplate
        });
    };

    $scope.hide = function () {
        $ionicLoading.hide();
    };

    $scope.showFailedAlert = function () {
        var alertPopup = $ionicPopup.alert({
            title: 'Login',
            css: 'cp-button',
            okType: 'cp-button',
            template: '<div style="width:100%;text-align:center">Login Failed. Please Check Your Internet Connection and Try Again</div>'
        });
    };

    $scope.showRequirementAlert = function () {
        var alertPopup = $ionicPopup.alert({
            title: 'Login',
            css: 'cp-button',
            okType: 'cp-button',
            template: '<div style="width:100%;text-align:center">Email and Password Must be Filled</div>'
        });
    };
    
    $scope.refreshMenu = function(){
        console.log("Login Refresh Menu Success");
        $scope.$emit('httpService:refreshMenu');
    }
});