app.controller("LoginRequiredCtrl", function ($scope,
                                              $rootScope,
                                              $http,
                                              $state,
                                              httpService,
                                              $cordovaDevice,
                                              $ionicLoading,
                                              $ionicPopup,
                                              $ionicPlatform,
                                              $ionicHistory) {

    $scope.isLoading = true;
    $scope.isTimeout = false;
    $scope.home_template = home_template;
    $scope.home_id = home_id;

    
    $scope.button_text_login = "Login";
    $scope.button_text_register = "Register";
    $scope.ui_text_forgot_password = "Forgot Password?";
    $scope.ui_text_click_here = "Click Here";
    $scope.ui_text_dont_have_account = "Don\'t have an account?";
    $scope.ui_text_sign_up_now = "Sign up now!";
    $scope.summernote_text_login_instruction = "";
    $scope.welcome_title = "Welcome!";
    $scope.welcome_subtitle = "Please Sign in or Sign up to continue";
    
    $scope.login_alert_title = "";
    $scope.login_failed_check_connection = "";
    $scope.login_error_try_again = "";
    $scope.login_requirement = "";
    $scope.login_success = "";
    $scope.login_failed_expired = "";
    $scope.login_failed_unapproved = "";
    $scope.login_failed_bound_device = "";
    $scope.login_failed_wrong_email_password = "";
    
    var translate_login_status = function(status_code)
    {
        if(status_code=="expired")
            return $scope.login_failed_expired;
        else if(status_code=="unapproved")
            return $scope.login_failed_unapproved;
        else if(status_code=="bound_device")
            return $scope.login_failed_bound_device;
        else if(status_code=="wrong_email_password")
            return $scope.login_failed_wrong_email_password;
        else if(status_code=="exception")
            return $scope.login_failed_wrong_email_password;
        else if(status_code=="success")
            return $scope.login_success;
    };
    
    $ionicPlatform.ready(function () {
        $scope.result = '';

        // initialize user login data, set '' for deployment
        $scope.input = {
            email: '',//'guest@compro.id',
            password: ''//'guestcompro'
        };

        $scope.username_login = username_login;

        if (user_id === '') {
            $scope.isLogin = false;
        } else {
            $scope.isLogin = true;
        }

        $scope.title = login_menu;

        
        var url = options_url;
        httpService.get($scope, $http, url, 'company-options');
    });
    
    $scope.$on('httpService:getCompanyOptionsRequestSuccess', function () {
        console.log('GET OPTIONS SUCCESS');
        $scope.isLoading = false;
        console.log($scope.data);

        updated_time = $scope.data.company.updated_at;
        //console.log('Updated At: ' + updated_time);
        var login_enabled = getPostMetaValueById($scope.data.options, "login_enabled");
        isLoginEnabled = login_enabled !== undefined ? (login_enabled.value == 'YES' ? true : false) : false;
        
        register_phone_required = getPostMetaValueById($scope.data.options, "register_phone_required") !== undefined ? getPostMetaValueById($scope.data.options, "register_phone_required").value : 'NO';        
        register_address_required = getPostMetaValueById($scope.data.options, "register_address_required") !== undefined ? getPostMetaValueById($scope.data.options, "register_address_required").value : 'NO';
        register_message_required = getPostMetaValueById($scope.data.options, "register_message_required") !== undefined ? getPostMetaValueById($scope.data.options, "register_message_required").value : 'NO';

        audioDownloadEnabled = getPostMetaValueById($scope.data.options, "audio_download_enabled")!== undefined ? (getPostMetaValueById($scope.data.options, "audio_download_enabled").value == 'YES' ? true : false) : false;

        canAttendEvent = getPostMetaValueById($scope.data.options, "can_attend_event") !== undefined ? (getPostMetaValueById($scope.data.options, "can_attend_event").value == 'YES' ? true : false):false;

        home_share_apps = getPostMetaValueById($scope.data.options, "home_share_apps") !== undefined ? (getPostMetaValueById($scope.data.options, "home_share_apps").value == 'YES' ? true : false):false;

        isDeviceLogin = getPostMetaValueById($scope.data.options, "is_device_login") !== undefined ? (getPostMetaValueById($scope.data.options, "is_device_login").value == 'YES' ? true : false):false;

        shopping_enabled = getPostMetaValueById($scope.data.options, "shopping_enabled") !== undefined ? (getPostMetaValueById($scope.data.options, "shopping_enabled").value == 'YES' ? true : false):false;
        
        currency = getPostMetaValueById($scope.data.options, "price_currency") !== undefined ? getPostMetaValueById($scope.data.options, "price_currency").value : 'Rp';
        
        stock_status_visible = getPostMetaValueById($scope.data.options, "stock_status_visible") !== undefined ? getPostMetaValueById($scope.data.options, "stock_status_visible").value : 'NO';
        
        booking_enabled = getPostMetaValueById($scope.data.options, "booking_enabled") !== undefined ? (getPostMetaValueById($scope.data.options, "booking_enabled").value == 'YES' ? true : false):false;
        
        playstore_link = getPostMetaValueById($scope.data.options, "link_playstore") !== undefined ? getPostMetaValueById($scope.data.options, "link_playstore").value : '';
        appstore_link = getPostMetaValueById($scope.data.options, "link_appstore") !== undefined ? getPostMetaValueById($scope.data.options, "link_appstore").value : '';
        
        inAppPurchaseEnabled = getPostMetaValueById($scope.data.options, "in_app_purchase_enabled") !== undefined ? (getPostMetaValueById($scope.data.options, "in_app_purchase_enabled").value == 'YES' ? true : false):false;
        
        
        is_membership_enabled = getPostMetaValueById($scope.data.options, "is_membership_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "is_membership_enabled").value : 'NO';
        
        membership_product_data_android = getPostMetaValueById($scope.data.options, "membership_product_data_android");
        membership_product_data_android = JSON.parse(membership_product_data_android !== undefined ? membership_product_data_android.value : "[]");

        custom_register_fields  = getPostMetaValueById($scope.data.options, "custom_register_fields") !== undefined ? getPostMetaValueById($scope.data.options, "custom_register_fields").value : false;
        default_register_fields  = getPostMetaValueById($scope.data.options, "default_register_fields") !== undefined ? getPostMetaValueById($scope.data.options, "default_register_fields").value : false;
        
        vt_payment_service = getPostMetaValueById($scope.data.options, "vt_payment_service") !== undefined ? getPostMetaValueById($scope.data.options, "vt_payment_service").value : 'NO';
        
        rajaongkir_enabled = getPostMetaValueById($scope.data.options, "rajaongkir_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "rajaongkir_enabled").value : 'NO';
        
        rajaongkir_sender_city_id = getPostMetaValueById($scope.data.options, "rajaongkir_sender_city_id") !== undefined ? getPostMetaValueById($scope.data.options, "rajaongkir_sender_city_id").value : '152';

        rajaongkir_selected_services = getPostMetaValueById($scope.data.options, "rajaongkir_selected_services") !== undefined ? getPostMetaValueById($scope.data.options, "rajaongkir_selected_services").value : '';

        maintenance_enabled = getPostMetaValueById($scope.data.options, "maintenance_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "maintenance_enabled").value : 'NO';
        
        sku_enabled = getPostMetaValueById($scope.data.options, "sku_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "sku_enabled").value : 'NO';

        default_menu_titles =  getPostMetaValueById($scope.data.options, "default_menu_titles") !== undefined ? getPostMetaValueById($scope.data.options, "default_menu_titles").value : false;
        
        if(default_menu_titles!=false)
        {
            default_menu_titles = JSON.parse(default_menu_titles);
            console.log(default_menu_titles);
            
            menu_text_login = default_menu_titles.login !== undefined && default_menu_titles.login[language]!==undefined ? default_menu_titles.login[language] : "Login";
            $scope.button_text_login = menu_text_login;

            menu_text_register = default_menu_titles.register !== undefined && default_menu_titles.register[language]!==undefined ? default_menu_titles.register[language] : "Register";
            $scope.button_text_register = menu_text_register;

            menu_text_ui_text_forgot_password = default_menu_titles.ui_text_forgot_password !== undefined && default_menu_titles.ui_text_forgot_password[language]!==undefined ? default_menu_titles.ui_text_forgot_password[language] : "Forgot Password?";
            $scope.ui_text_forgot_password = menu_text_ui_text_forgot_password;

            menu_text_ui_text_click_here = default_menu_titles.ui_text_click_here !== undefined && default_menu_titles.ui_text_click_here[language]!==undefined ? default_menu_titles.ui_text_click_here[language] : "Click Here";
            $scope.ui_text_click_here = menu_text_ui_text_click_here;

            menu_text_welcome_title = default_menu_titles.welcome_title !== undefined && default_menu_titles.welcome_title[language]!==undefined ? default_menu_titles.welcome_title[language] : "Welcome!";
            $scope.welcome_title = menu_text_welcome_title;

            menu_text_welcome_subtitle = default_menu_titles.welcome_subtitle !== undefined && default_menu_titles.welcome_subtitle[language]!==undefined ? default_menu_titles.welcome_subtitle[language] : "Please Sign in or Sign up to continue";
            $scope.welcome_subtitle = menu_text_welcome_subtitle;

            menu_text_ui_text_dont_have_account = default_menu_titles.ui_text_dont_have_account !== undefined && default_menu_titles.ui_text_dont_have_account[language]!==undefined ? default_menu_titles.ui_text_dont_have_account[language] : "Don\'t have an account?";
            $scope.ui_text_dont_have_account = menu_text_ui_text_dont_have_account;

            menu_text_ui_text_sign_up_now = default_menu_titles.ui_text_sign_up_now !== undefined && default_menu_titles.ui_text_sign_up_now[language]!==undefined ? default_menu_titles.ui_text_sign_up_now[language] : "Sign up now!";
            $scope.ui_text_sign_up_now = menu_text_ui_text_sign_up_now;
        }
        else
        {
            
        }
        
        ui_texts_products =  getPostMetaValueById($scope.data.options, "ui_texts_products") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_products").value : false;
        
        if(ui_texts_products!=false)
        {
            ui_texts_products = JSON.parse(ui_texts_products);
        }
        
        ui_texts_events =  getPostMetaValueById($scope.data.options, "ui_texts_events") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_events").value : false;
        
        if(ui_texts_events!=false)
        {
            ui_texts_events = JSON.parse(ui_texts_events);
        }
        
        ui_texts_bookings =  getPostMetaValueById($scope.data.options, "ui_texts_bookings") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_bookings").value : false;
        
        if(ui_texts_bookings!=false)
        {
            ui_texts_bookings = JSON.parse(ui_texts_bookings);
        }
        
        ui_texts_careers =  getPostMetaValueById($scope.data.options, "ui_texts_careers") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_careers").value : false;
        
        if(ui_texts_careers!=false)
        {
            ui_texts_careers = JSON.parse(ui_texts_careers);
        }
        
        ui_texts_audios =  getPostMetaValueById($scope.data.options, "ui_texts_audios") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_audios").value : false;
        
        if(ui_texts_audios!=false)
        {
            ui_texts_audios = JSON.parse(ui_texts_audios);
        }
        
        ui_texts_custom_forms =  getPostMetaValueById($scope.data.options, "ui_texts_custom_forms") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_custom_forms").value : false;
        
        if(ui_texts_custom_forms!=false)
        {
            ui_texts_custom_forms = JSON.parse(ui_texts_custom_forms);
        }
        
        ui_texts_files =  getPostMetaValueById($scope.data.options, "ui_texts_files") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_files").value : false;
        
        if(ui_texts_files!=false)
        {
            ui_texts_files = JSON.parse(ui_texts_files);
        }
        
        ui_texts_webviews =  getPostMetaValueById($scope.data.options, "ui_texts_webviews") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_webviews").value : false;
        
        if(ui_texts_webviews!=false)
        {
            ui_texts_webviews = JSON.parse(ui_texts_webviews);
        }
        
        ui_texts_contacts =  getPostMetaValueById($scope.data.options, "ui_texts_contacts") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_contacts").value : false;
        
        if(ui_texts_contacts!=false)
        {
            ui_texts_contacts = JSON.parse(ui_texts_contacts);
        }
        
        ui_texts_contact_forms =  getPostMetaValueById($scope.data.options, "ui_texts_contact_forms") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_contact_forms").value : false;
        
        if(ui_texts_contact_forms!=false)
        {
            ui_texts_contact_forms = JSON.parse(ui_texts_contact_forms);
        }
        
        ui_texts_transactions =  getPostMetaValueById($scope.data.options, "ui_texts_transactions") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_transactions").value : false;
        
        if(ui_texts_transactions!=false)
        {
            ui_texts_transactions = JSON.parse(ui_texts_transactions);
        }
        
        ui_texts_manual_payments =  getPostMetaValueById($scope.data.options, "ui_texts_manual_payments") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_manual_payments").value : false;
        
        if(ui_texts_manual_payments!=false)
        {
            ui_texts_manual_payments = JSON.parse(ui_texts_manual_payments);
        }
        
        ui_texts_shopping_cart =  getPostMetaValueById($scope.data.options, "ui_texts_shopping_cart") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_shopping_cart").value : false;
        
        if(ui_texts_shopping_cart!=false)
        {
            ui_texts_shopping_cart = JSON.parse(ui_texts_shopping_cart);
        }
        
        ui_texts_register =  getPostMetaValueById($scope.data.options, "ui_texts_register") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_register").value : false;
        
        if(ui_texts_register!=false)
        {
            ui_texts_register = JSON.parse(ui_texts_register);
        }
        
        ui_texts_login =  getPostMetaValueById($scope.data.options, "ui_texts_login") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_login").value : false;
        
        if(ui_texts_login!=false)
        {
            ui_texts_login = JSON.parse(ui_texts_login);
            
            $scope.summernote_text_login_instruction =  ui_texts_login.summernote_text_login_instruction !== undefined && ui_texts_login.summernote_text_login_instruction[language]!==undefined ? ui_texts_login.summernote_text_login_instruction[language] : $scope.summernote_text_login_instruction;
        }
        
        custom_feedback_message =  getPostMetaValueById($scope.data.options, "custom_feedback_message") !== undefined ? getPostMetaValueById($scope.data.options, "custom_feedback_message").value : false;
        
        if(custom_feedback_message!=false)
            custom_feedback_message = JSON.parse(custom_feedback_message);
        
        login_alert_title = custom_feedback_message.login_alert_title !== undefined && custom_feedback_message.login_alert_title[language]!==undefined ? custom_feedback_message.login_alert_title[language] : "Login";
        $scope.login_alert_title = login_alert_title;
        
        login_failed_check_connection = custom_feedback_message.login_failed_check_connection !== undefined && custom_feedback_message.login_failed_check_connection[language]!==undefined ? custom_feedback_message.login_failed_check_connection[language] : "Login Failed. Please Check Your Internet Connection and Try Again";
        $scope.login_failed_check_connection = login_failed_check_connection;
        
        login_error_try_again = custom_feedback_message.login_error_try_again !== undefined && custom_feedback_message.login_error_try_again[language]!==undefined ? custom_feedback_message.login_error_try_again[language] : "Login Error. Please Try Again";
        $scope.login_error_try_again = login_failed_check_connection;
        
        login_requirement = custom_feedback_message.login_requirement !== undefined && custom_feedback_message.login_requirement[language]!==undefined ? custom_feedback_message.login_requirement[language] : "Email and Password Must be Filled";
        $scope.login_requirement = login_requirement;
        
        login_failed_expired = custom_feedback_message.login_failed_expired !== undefined && custom_feedback_message.login_failed_expired[language]!==undefined ? custom_feedback_message.login_failed_expired[language] : "Your account has been expired. Please top up first.";
        $scope.login_failed_expired = login_failed_expired;
        
        login_failed_unapproved = custom_feedback_message.login_failed_unapproved !== undefined && custom_feedback_message.login_failed_unapproved[language]!==undefined ? custom_feedback_message.login_failed_unapproved[language] : "Your account has not been approved by our Administrator.";
        $scope.login_failed_unapproved = login_failed_unapproved;
        
        login_failed_bound_device = custom_feedback_message.login_failed_bound_device !== undefined && custom_feedback_message.login_failed_bound_device[language]!==undefined ? custom_feedback_message.login_failed_bound_device[language] : "Your account is bound to another device!";
        $scope.login_failed_bound_device = login_failed_bound_device;
        
        login_failed_wrong_email_password = custom_feedback_message.login_failed_wrong_email_password !== undefined && custom_feedback_message.login_failed_wrong_email_password[language]!==undefined ? custom_feedback_message.login_failed_wrong_email_password[language] : "Wrong email or password!";
        $scope.login_failed_wrong_email_password = login_failed_wrong_email_password;
        
        login_success = custom_feedback_message.login_success !== undefined && custom_feedback_message.login_success[language]!==undefined ? custom_feedback_message.login_success[language] : "Login success!";
        $scope.login_success = login_success;
        
        console.log(custom_feedback_message);


        //check if maintenance
        if (maintenance_enabled == 'YES')
        {
            $state.go('maintenance');
        }
//        var productIds = [];
//        var duration_lists = '{';
//        for (var i = 0; i < membership_product_data_android.length; i++) { 
//            productIds.push(membership_product_data_android[i].productId);
//            if(i>0)
//                duration_lists+=',';
//            duration_lists+='"'+membership_product_data_android[i].productId+'":'+membership_product_data_android[i].duration;
//        }
//        duration_lists+='}';
//        duration_lists = JSON.parse(duration_lists);
//        
//        console.log(duration_lists[productIds[0]]);
        
        if (isPhoneGap()) {
            saveTermJSONToDB(-2, 'LoginRequiredCtrl', $scope.data);
        }
    });
    
    $scope.$on('httpService:getCompanyOptionsRequestError', function () {
        if ($scope.status === 0 || $scope.status == '' || $scope.status == '-1') {
            console.log('NO INTERNET CONNECTION');
            if (isPhoneGap()) {
                loadTermJSONFromDB(-2, $scope);
            }
        }
        else {
            var url = options_url;
            httpService.get($scope, $http, url, 'company-options');
        }
        // httpService.post_token($scope, $http, url, obj, 'menu');


    });
    
    $scope.$on('SQLite:getOfflineOptionsSuccess', function () {
        //console.log($scope.data);
        main_menu = $scope.data.terms;
        console.log("GET MENU SUCCESS");
        //console.log(main_menu);

        var login_enabled = getPostMetaValueById($scope.data.options, "login_enabled");
        isLoginEnabled = login_enabled !== undefined ? (login_enabled.value == 'YES' ? true : false) : false;
        
        register_phone_required = getPostMetaValueById($scope.data.options, "register_phone_required") !== undefined ? getPostMetaValueById($scope.data.options, "register_phone_required").value : 'NO';        
        register_address_required = getPostMetaValueById($scope.data.options, "register_address_required") !== undefined ? getPostMetaValueById($scope.data.options, "register_address_required").value : 'NO';
        register_message_required = getPostMetaValueById($scope.data.options, "register_message_required") !== undefined ? getPostMetaValueById($scope.data.options, "register_message_required").value : 'NO';

        audioDownloadEnabled = getPostMetaValueById($scope.data.options, "audio_download_enabled")!== undefined ? (getPostMetaValueById($scope.data.options, "audio_download_enabled").value == 'YES' ? true : false) : false;

        canAttendEvent = getPostMetaValueById($scope.data.options, "can_attend_event") !== undefined ? (getPostMetaValueById($scope.data.options, "can_attend_event").value == 'YES' ? true : false):false;

        home_share_apps = getPostMetaValueById($scope.data.options, "home_share_apps") !== undefined ? (getPostMetaValueById($scope.data.options, "home_share_apps").value == 'YES' ? true : false):false;

        isDeviceLogin = getPostMetaValueById($scope.data.options, "is_device_login") !== undefined ? (getPostMetaValueById($scope.data.options, "is_device_login").value == 'YES' ? true : false):false;

        shopping_enabled = getPostMetaValueById($scope.data.options, "shopping_enabled") !== undefined ? (getPostMetaValueById($scope.data.options, "shopping_enabled").value == 'YES' ? true : false):false;
        
        currency = getPostMetaValueById($scope.data.options, "price_currency") !== undefined ? getPostMetaValueById($scope.data.options, "price_currency").value : 'Rp';
        
        stock_status_visible = getPostMetaValueById($scope.data.options, "stock_status_visible") !== undefined ? getPostMetaValueById($scope.data.options, "stock_status_visible").value : 'NO';
        
        booking_enabled = getPostMetaValueById($scope.data.options, "booking_enabled") !== undefined ? (getPostMetaValueById($scope.data.options, "booking_enabled").value == 'YES' ? true : false):false;
        
        playstore_link = getPostMetaValueById($scope.data.options, "link_playstore") !== undefined ? getPostMetaValueById($scope.data.options, "link_playstore").value : '';
        appstore_link = getPostMetaValueById($scope.data.options, "link_appstore") !== undefined ? getPostMetaValueById($scope.data.options, "link_appstore").value : '';
        
        inAppPurchaseEnabled = getPostMetaValueById($scope.data.options, "in_app_purchase_enabled") !== undefined ? (getPostMetaValueById($scope.data.options, "in_app_purchase_enabled").value == 'YES' ? true : false):false;
        
        
        is_membership_enabled = getPostMetaValueById($scope.data.options, "is_membership_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "is_membership_enabled").value : 'NO';
        
        membership_product_data_android = getPostMetaValueById($scope.data.options, "membership_product_data_android");
        membership_product_data_android = JSON.parse(membership_product_data_android !== undefined ? membership_product_data_android.value : "[]");
        
        custom_register_fields  = getPostMetaValueById($scope.data.options, "custom_register_fields") !== undefined ? getPostMetaValueById($scope.data.options, "custom_register_fields").value : false;
        default_register_fields  = getPostMetaValueById($scope.data.options, "default_register_fields") !== undefined ? getPostMetaValueById($scope.data.options, "default_register_fields").value : false;
        
        vt_payment_service = getPostMetaValueById($scope.data.options, "vt_payment_service") !== undefined ? getPostMetaValueById($scope.data.options, "vt_payment_service").value : 'NO';
        
        rajaongkir_enabled = getPostMetaValueById($scope.data.options, "rajaongkir_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "rajaongkir_enabled").value : 'NO';
        
        rajaongkir_sender_city_id = getPostMetaValueById($scope.data.options, "rajaongkir_sender_city_id") !== undefined ? getPostMetaValueById($scope.data.options, "rajaongkir_sender_city_id").value : '152';

        rajaongkir_selected_services = getPostMetaValueById($scope.data.options, "rajaongkir_selected_services") !== undefined ? getPostMetaValueById($scope.data.options, "rajaongkir_selected_services").value : '';

        maintenance_enabled = getPostMetaValueById($scope.data.options, "maintenance_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "maintenance_enabled").value : 'NO';
        
        sku_enabled = getPostMetaValueById($scope.data.options, "sku_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "sku_enabled").value : 'NO';

        default_menu_titles =  getPostMetaValueById($scope.data.options, "default_menu_titles") !== undefined ? getPostMetaValueById($scope.data.options, "default_menu_titles").value : false;

        if(default_menu_titles!=false)
        {
            default_menu_titles = JSON.parse(default_menu_titles);
            console.log(default_menu_titles);
            
            menu_text_login = default_menu_titles.login !== undefined && default_menu_titles.login[language]!==undefined ? default_menu_titles.login[language] : "Login";
            $scope.button_text_login = menu_text_login;

            menu_text_register = default_menu_titles.register !== undefined && default_menu_titles.register[language]!==undefined ? default_menu_titles.register[language] : "Register";
            $scope.button_text_register = menu_text_register;

            menu_text_ui_text_forgot_password = default_menu_titles.ui_text_forgot_password !== undefined && default_menu_titles.ui_text_forgot_password[language]!==undefined ? default_menu_titles.ui_text_forgot_password[language] : "Forgot Password?";
            $scope.ui_text_forgot_password = menu_text_ui_text_forgot_password;

            menu_text_ui_text_click_here = default_menu_titles.ui_text_click_here !== undefined && default_menu_titles.ui_text_click_here[language]!==undefined ? default_menu_titles.ui_text_click_here[language] : "Click Here";
            $scope.ui_text_click_here = menu_text_ui_text_click_here;

            menu_text_welcome_title = default_menu_titles.welcome_title !== undefined && default_menu_titles.welcome_title[language]!==undefined ? default_menu_titles.welcome_title[language] : "Welcome!";
            $scope.welcome_title = menu_text_welcome_title;

            menu_text_welcome_subtitle = default_menu_titles.welcome_subtitle !== undefined && default_menu_titles.welcome_subtitle[language]!==undefined ? default_menu_titles.welcome_subtitle[language] : "Please Sign in or Sign up to continue";
            $scope.welcome_subtitle = menu_text_welcome_subtitle;

            menu_text_ui_text_dont_have_account = default_menu_titles.ui_text_dont_have_account !== undefined && default_menu_titles.ui_text_dont_have_account[language]!==undefined ? default_menu_titles.ui_text_dont_have_account[language] : "Don\'t have an account?";
            $scope.ui_text_dont_have_account = menu_text_ui_text_dont_have_account;

            menu_text_ui_text_sign_up_now = default_menu_titles.ui_text_sign_up_now !== undefined && default_menu_titles.ui_text_sign_up_now[language]!==undefined ? default_menu_titles.ui_text_sign_up_now[language] : "Sign up now!";
            $scope.ui_text_sign_up_now = menu_text_ui_text_sign_up_now;
        }
        else
        {
            
        }
        
        ui_texts_products =  getPostMetaValueById($scope.data.options, "ui_texts_products") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_products").value : false;
        
        if(ui_texts_products!=false)
        {
            ui_texts_products = JSON.parse(ui_texts_products);
        }
        
        ui_texts_events =  getPostMetaValueById($scope.data.options, "ui_texts_events") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_events").value : false;
        
        if(ui_texts_events!=false)
        {
            ui_texts_events = JSON.parse(ui_texts_events);
        }
        
        ui_texts_bookings =  getPostMetaValueById($scope.data.options, "ui_texts_bookings") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_bookings").value : false;
        
        if(ui_texts_bookings!=false)
        {
            ui_texts_bookings = JSON.parse(ui_texts_bookings);
        }
        
        ui_texts_careers =  getPostMetaValueById($scope.data.options, "ui_texts_careers") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_careers").value : false;
        
        if(ui_texts_careers!=false)
        {
            ui_texts_careers = JSON.parse(ui_texts_careers);
        }
        
        ui_texts_audios =  getPostMetaValueById($scope.data.options, "ui_texts_audios") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_audios").value : false;
        
        if(ui_texts_audios!=false)
        {
            ui_texts_audios = JSON.parse(ui_texts_audios);
        }
        
        ui_texts_custom_forms =  getPostMetaValueById($scope.data.options, "ui_texts_custom_forms") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_custom_forms").value : false;
        
        if(ui_texts_custom_forms!=false)
        {
            ui_texts_custom_forms = JSON.parse(ui_texts_custom_forms);
        }
        
        ui_texts_files =  getPostMetaValueById($scope.data.options, "ui_texts_files") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_files").value : false;
        
        if(ui_texts_files!=false)
        {
            ui_texts_files = JSON.parse(ui_texts_files);
        }
        
        ui_texts_webviews =  getPostMetaValueById($scope.data.options, "ui_texts_webviews") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_webviews").value : false;
        
        if(ui_texts_webviews!=false)
        {
            ui_texts_webviews = JSON.parse(ui_texts_webviews);
        }
        
        ui_texts_contacts =  getPostMetaValueById($scope.data.options, "ui_texts_contacts") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_contacts").value : false;
        
        if(ui_texts_contacts!=false)
        {
            ui_texts_contacts = JSON.parse(ui_texts_contacts);
        }
        
        ui_texts_contact_forms =  getPostMetaValueById($scope.data.options, "ui_texts_contact_forms") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_contact_forms").value : false;
        
        if(ui_texts_contact_forms!=false)
        {
            ui_texts_contact_forms = JSON.parse(ui_texts_contact_forms);
        }
        
        ui_texts_transactions =  getPostMetaValueById($scope.data.options, "ui_texts_transactions") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_transactions").value : false;
        
        if(ui_texts_transactions!=false)
        {
            ui_texts_transactions = JSON.parse(ui_texts_transactions);
        }
        
        ui_texts_manual_payments =  getPostMetaValueById($scope.data.options, "ui_texts_manual_payments") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_manual_payments").value : false;
        
        if(ui_texts_manual_payments!=false)
        {
            ui_texts_manual_payments = JSON.parse(ui_texts_manual_payments);
        }
        
        ui_texts_shopping_cart =  getPostMetaValueById($scope.data.options, "ui_texts_shopping_cart") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_shopping_cart").value : false;
        
        if(ui_texts_shopping_cart!=false)
        {
            ui_texts_shopping_cart = JSON.parse(ui_texts_shopping_cart);
        }
        
        ui_texts_register =  getPostMetaValueById($scope.data.options, "ui_texts_register") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_register").value : false;
        
        if(ui_texts_register!=false)
        {
            ui_texts_register = JSON.parse(ui_texts_register);
        }
        
        ui_texts_login =  getPostMetaValueById($scope.data.options, "ui_texts_login") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_login").value : false;
        
        if(ui_texts_login!=false)
        {
            ui_texts_login = JSON.parse(ui_texts_login);
            
            $scope.summernote_text_login_instruction =  ui_texts_login.summernote_text_login_instruction !== undefined && ui_texts_login.summernote_text_login_instruction[language]!==undefined ? ui_texts_login.summernote_text_login_instruction[language] : $scope.summernote_text_login_instruction;
        }
        
        
        custom_feedback_message =  getPostMetaValueById($scope.data.options, "custom_feedback_message") !== undefined ? getPostMetaValueById($scope.data.options, "custom_feedback_message").value : false;

        $scope.isloading = false;
    });
    // function for login
    $scope.login = function () {

        if ($scope.input.email !== '' && $scope.input.password !== '') {
            $scope.show();

            var url = login_url;
            var input = $scope.input;
            var device_id = '';
            if (isPhoneGap()) {
                device_id = $cordovaDevice.getDevice().uuid;
            }
            console.log(input);
            var obj = serializeData({email: input.email, password: input.password, company_id: company_id, device_id: device_id});

            httpService.post($scope, $http, url, obj);
        } else {
            $scope.showRequirementAlert();
        }

    };

    // if post login data success
    $scope.$on('httpService:postRequestSuccess', function () {
        $scope.result = $scope.data;
        console.log($scope.result);

        $scope.hide();

        if($scope.result.message == null || $scope.result.message == '' || $scope.result.message == undefined)
        {
            $scope.showFailedAlert();
        }

        // if user authentication success
        if ($scope.result.success === true) {

            if (isPhoneGap()) {
                // save user login to database
                console.log(db);
                if (db === '') {
                    db = window.sqlitePlugin.openDatabase({name: sqlitedb, location: 'default'});
                }

                db.transaction(function (tx) {
                    console.log($scope.result.user.id + ' ' + $scope.result.user.username);
                    tx.executeSql('CREATE TABLE IF NOT EXISTS ' + user_table + ' (id integer primary key, user text)');
                    tx.executeSql('DELETE FROM ' + user_table);
                    tx.executeSql("INSERT INTO " + user_table + " (id, user) VALUES (?,?)", [$scope.result.user.id, JSON.stringify($scope.result.user)], function (tx, res) {
                        console.log("insertId: " + res.insertId + " -- probably 1");
                        console.log("rowsAffected: " + res.rowsAffected + " -- should be 1");

                        //$scope.showAlert($scope.login_alert_title, $scope.result.message);
                        $scope.showAlert($scope.login_alert_title, translate_login_status($scope.result.status_code));
                        user_id = $scope.result.user.id;
                        username_login = $scope.result.user.username;
                        email = $scope.result.user.email;

                        if(getPostMetaValueById($scope.result.user.company_user_meta, 'address') != null && getPostMetaValueById($scope.result.user.company_user_meta, 'address') != undefined)
                        {
                            address = getPostMetaValueById($scope.result.user.company_user_meta, 'address').value;
                        }

                        if(getPostMetaValueById($scope.result.user.company_user_meta, 'phone') != null && getPostMetaValueById($scope.result.user.company_user_meta, 'phone') != undefined)
                        {
                            phone = getPostMetaValueById($scope.result.user.company_user_meta, 'phone').value;
                        }

                        console.log(username_login + ' ' + user_id + ' ' + email + ' ' + phone);
                        console.log(user_id);
                        login_menu = 'User';
                        $scope.title = login_menu;
                        $scope.username_login = username_login;
                        $scope.isLogin = true;
                        $rootScope.isLoggedIn = true;
                        main_menu['transaction_list'] = $scope.isLogin;
                        $rootScope.transaction_count = $scope.result['transaction_count'];

                        window.location.href = "#/app/" + home_template + "/" + home_id;
                        
                        $rootScope.user_id = user_id;
                        $scope.refreshMenu();
                    }, function (e) {
                        console.log("ERROR: " + e.message);
                        $scope.isLogin = false;
                        $rootScope.isLoggedIn = false;
                        main_menu['transaction_list'] = $scope.isLogin;
                        $rootScope.transaction_count = $scope.result['transaction_count'];
                        $scope.showAlert($scope.login_alert_title, $scope.login_error_try_again);
                    });
                });
            }
            else {
                //$scope.showAlert($scope.login_alert_title, $scope.result.message);
                $scope.showAlert($scope.login_alert_title, translate_login_status($scope.result.status_code));
                user_id = $scope.result.user.id;
                username_login = $scope.result.user.username;
                email = $scope.result.user.email;

                if(getPostMetaValueById($scope.result.user.company_user_meta, 'address') != null && getPostMetaValueById($scope.result.user.company_user_meta, 'address') != undefined)
                {
                    address = getPostMetaValueById($scope.result.user.company_user_meta, 'address').value;
                }

                if(getPostMetaValueById($scope.result.user.company_user_meta, 'phone') != null && getPostMetaValueById($scope.result.user.company_user_meta, 'phone') != undefined)
                {
                    phone = getPostMetaValueById($scope.result.user.company_user_meta, 'phone').value;
                }
                console.log(username_login + ' ' + user_id + ' ' + email + ' ' + phone + ' ' + address);
                login_menu = 'User';
                $scope.title = login_menu;
                $scope.username_login = username_login;
                $scope.isLogin = true;
                $rootScope.isLoggedIn = true;
                main_menu['transaction_list'] = $scope.isLogin;
                $rootScope.transaction_count = $scope.result['transaction_count'];
                console.log("UPDATED");
                console.log("ROOT SCOPE UPDATE" + $rootScope.transaction_count);

                window.location.href = "#/app/" + home_template + "/" + home_id;
                
                $rootScope.user_id = user_id;
                $scope.refreshMenu();
            }

        }
        else {
            //if expired and needs top-up
            if($scope.result.status_code === 'expired' && is_membership_enabled == 'YES')
            {
                //$scope.showAlert($scope.login_alert_title, $scope.result.message);
                $scope.showAlert($scope.login_alert_title, translate_login_status($scope.result.status_code));
                user_id = $scope.result.user.id;
                username_login = $scope.result.user.username;
                email = $scope.result.user.email;
                is_expired = true;
                
                if(getPostMetaValueById($scope.result.user.company_user_meta, 'address') != null && getPostMetaValueById($scope.result.user.company_user_meta, 'address') != undefined)
                {
                    address = getPostMetaValueById($scope.result.user.company_user_meta, 'address').value;
                }

                if(getPostMetaValueById($scope.result.user.company_user_meta, 'phone') != null && getPostMetaValueById($scope.result.user.company_user_meta, 'phone') != undefined)
                {
                    phone = getPostMetaValueById($scope.result.user.company_user_meta, 'phone').value;
                }
                console.log(username_login + ' ' + user_id + ' ' + email + ' ' + phone + ' ' + address);
                login_menu = 'User';
                $scope.title = login_menu;
                $scope.username_login = username_login;

                window.location.href = "#/front-top-up/-6";
            }
            else
            {
                $scope.isLogin = false;
                $rootScope.isLoggedIn = false;
                main_menu['transaction_list'] = $scope.isLogin;
                $rootScope.transaction_count = $scope.result['transaction_count'];
                //$scope.showAlert($scope.login_alert_title, $scope.result.message);
                $scope.showAlert($scope.login_alert_title, translate_login_status($scope.result.status_code));
            }
        }

    });

    $scope.$on('httpService:postRequestError', function () {
        $scope.hide();
        $scope.showFailedAlert();
    });


    $scope.show = function () {
        $ionicLoading.show({
            template: ionicLoadingTemplate
        });
    };
    
    $scope.hide = function () {
        $ionicLoading.hide();
    };

    $scope.showAlert = function (title, message) {
        var alertPopup = $ionicPopup.alert({
            title: title,
            css: 'cp-button',
            template: '<div style="width:100%;text-align:center">' + message + '</div>',
            okType:'cp-button'
        });
    };


    $scope.showFailedAlert = function () {
        var alertPopup = $ionicPopup.alert({
            title: $scope.login_alert_title,
            css: 'cp-button',
            okType:'cp-button',
            template: '<div style="width:100%;text-align:center">'+$scope.login_failed_check_connection+'</div>'
        });
    };

    $scope.showRequirementAlert = function () {
        var alertPopup = $ionicPopup.alert({
            title: $scope.login_alert_title,
            css: 'cp-button',
            okType:'cp-button', 
            template: '<div style="width:100%;text-align:center">'+$scope.login_requirement+'</div>'
        });
    };

    // override back button

    $scope.clearHistory = function () {
        $ionicHistory.nextViewOptions({
            disableBack: true
        });
        $ionicHistory.clearCache();
        $ionicHistory.clearHistory();
    };

    $scope.$on('$destroy', function () {
        doregisterHardBack();

    });

    var doCustomBack = function () {
        $scope.clearHistory();
        $scope.showExitConfirmation = function () {
            var confirmPopup = $ionicPopup.confirm({
                title: 'Exit Application',
                css: 'cp-button',
                template: "<div style='display:flex;justify-content:center;align-items:center;'>Are you sure want to exit?</div>",
                okType:'cp-button'
            });

            //confirmation dialog
            confirmPopup.then(function (res) {
                if (res) {
                    ionic.Platform.exitApp();
                }
            });
        };

        $scope.showExitConfirmation();
    };

    var doregisterHardBack = $ionicPlatform.registerBackButtonAction(doCustomBack, 101);
    
    $scope.refreshMenu = function(){
        console.log("Login Refresh Menu Success");
        $scope.$emit('httpService:refreshMenu');
    }
    
});