app.controller("ResetPasswordCtrl", function ($scope,
                                               $http,
                                               httpService,
                                               $stateParams,
                                               $ionicPlatform,
                                               $ionicPopup,
                                               $ionicLoading) {

    $scope.input = {
        user_email: ''
    };

    $scope.resetPassword = function()
    {
        // get data
        $scope.show();
        var obj = serializeData({user_email: $scope.input.user_email, company_id: company_id});

        httpService.post($scope, $http, reset_password_url, obj);
    };

    // get data success
    $scope.$on('httpService:postRequestSuccess', function () {
        $scope.hide();
        //console.log($scope.data);
        if($scope.data.success === true)
        {
            $scope.showResetPasswordSuccessAlert();
        }
        else
        {
            $scope.showResetPasswordFailedAlert();
        }

    });

    // if get detail data Error, request token again
    $scope.$on('httpService:postRequestError', function () {
        $scope.hide();
        $scope.showResetPasswordFailedAlert();
    });

    $scope.show = function () {
        $ionicLoading.show({
            template: ionicLoadingTemplate
        });
    };

    $scope.hide = function () {
        $ionicLoading.hide();
    };

    $scope.showResetPasswordSuccessAlert = function (username) {
        var alertPopup = $ionicPopup.alert({
            title: 'Reset Password',
            template: '<div style="width:100%;text-align:center">An email on how to reset your password has been sent. Please check your email.</div>'
        });
    };

    $scope.showResetPasswordFailedAlert = function (username) {
        var alertPopup = $ionicPopup.alert({
            title: 'Reset Password',
            template: '<div style="width:100%;text-align:center">Failed to reset password. Please check Your Internet Connection and Try Again</div>'
        });
    };

});

