app.controller("RssReaderCtrl", function ($scope, $http, httpService, $stateParams, $ionicPlatform, $cordovaInAppBrowser) {

    // loading spinner in the beginning
    $scope.isLoading = true;
    $scope.isTimeout = false;

    $ionicPlatform.ready(function()
    {
        // check user login
        if (user_id === '') {
            $scope.isLogin = false;
        } else {
            $scope.isLogin = true;
        }
        
        $scope.isTimeout = false;

        var url = token_url;
        var obj = serializeData({email: username, password: password, company_id: company_id});
        // call angular http service
        httpService.post_token($scope, $http, url, obj);
    });

    
    $scope.openBrowser = function(url){
        if (!isPhoneGap()){
            window.open(url,'_blank','location=yes'); 
        }
        else {
            cordova.ThemeableBrowser.open(url, '_blank', {
                statusbar: {
                    color: '#ffffffff'
                },
                toolbar: {
                    height: 44,
                    color: '#ffffffff'
                },
                title: {
                    color: '#212121ff',
                    showPageTitle: true
                },
                backButton: {
                    wwwImage: 'images/drawable-xhdpi/back.png',
                    wwwImagePressed: 'images/drawable-xhdpi/back_pressed.png',
                    wwwImageDensity: 2,
                    align: 'left',
                    event: 'backPressed'
                },
                forwardButton: {
                    wwwImage: 'images/drawable-xhdpi/forward.png',
                    wwwImagePressed: 'images/drawable-xhdpi/forward_pressed.png',
                    wwwImageDensity: 2,
                    align: 'left',
                    event: 'forwardPressed'
                },
                closeButton: {
                    wwwImage: 'images/drawable-xhdpi/close.png',
                    wwwImagePressed: 'images/drawable-xhdpi/close_pressed.png',
                    wwwImageDensity: 2,
                    align: 'right',
                    event: 'closePressed'
                },
                backButtonCanClose: true
            });
        }        
    };

    // get token for getting detail data success
    $scope.$on('httpService:postTokenSuccess', function () {
        token = $scope.data.token;
        //console.log(token);
        //request compressed image or high res images
        var url = "";
        url = post_content_url + $stateParams.id;

            
        // get data
        httpService.get($scope, $http, url, 'content', token);
        console.log('RssReaderCtrl');

    });

    // get data success
    $scope.$on('httpService:getRequestSuccess', function () {        
        $scope.content_data = {
            id: $stateParams.id,
            title: $scope.data.post.title,
            created_date: $scope.data.post.published_date,
            img_src: $scope.data.post.featured_image_path,
            summary: $scope.data.post.summary,
            content: $scope.data.post.content
        };
        
        var rss_url = getPostMetaValueById($scope.data.post.post_meta,"rss_url").value;
        var rss_num = getPostMetaValueById($scope.data.post.post_meta,"rss_num").value;
        
        console.log(rss_url);
        console.log(rss_num);
        
        //$http.get("js/rss-dummy.json")
        $http.get("http://ajax.googleapis.com/ajax/services/feed/load", { params: { "v": "1.0", "q": rss_url, "num": rss_num } })
            .success(function(data) {
                $scope.isLoading = false;
                $scope.rssTitle = data.responseData.feed.title;
                $scope.rssUrl = data.responseData.feed.feedUrl;
                $scope.rssSiteUrl = data.responseData.feed.link;
                $scope.entries = data.responseData.feed.entries;
            })
            .error(function(data) {
                $scope.isTimeout = true;
                console.log("ERROR: " + data);
            });
        
        //$scope.isLoading = false;

        if(isPhoneGap())
        {
            //console.log($stateParams.id + " " + $scope.data.post.term_id + " " + 'ArticleDetailCtrl' + " " + $scope.data);
            savePostJSONToDB($stateParams.id, $scope.data.post.term_id, 'RssReaderCtrl', $scope.data);
            //console.log('saved');
        }

    });

    // if get token detail data Error, request token again
    $scope.$on('httpService:postTokenError', function () {
        if($scope.status === 0)
        {
            if(isPhoneGap())
            {
                loadPostJSONFromDB($stateParams.id, $scope);
            }


        }
        else {
            var url = token_url;
            var obj = serializeData({email: username, password: password, company_id: company_id});
            httpService.post_token($scope, $http, url, obj, 'content');
        }
    });

    // if get detail data Error, request token again
    $scope.$on('httpService:getRequestError', function () {
        var url = token_url;
        var obj = serializeData({email: username, password: password, company_id: company_id});
        $scope.isTimeout = true;
//        httpService.post_token($scope, $http, url, obj, 'content');

    });

    // loading fragment
    $scope.show = function () {
        $ionicLoading.show({
            template: ionicLoadingTemplate
        });
    };
    $scope.hide = function () {
        $ionicLoading.hide();
    };

    // alert fragment
    $scope.showSuccessAlert = function () {
        var alertPopup = $ionicPopup.alert({
            title: 'Comment',
            css: 'cp-button',
            okType:'cp-button',
            template: '<div style="width:100%;text-align:center">Your Comment Posted Successfully</div>'
        });
    };

    $scope.showFailedAlert = function () {
        var alertPopup = $ionicPopup.alert({
            title: 'Comment',
            css: 'cp-button',
            okType:'cp-button',
            template: '<div style="width:100%;text-align:center">Failed to Post Your Comment. Please Check Your Internet Connection and Try Again</div>'
        });
    };

    $scope.isPhoneGap = function()
    {
        return isPhoneGap();
    };
    
    $scope.addImageClass = function(html){
        return html.replace(/<img/g,"<img class='full-image-auto-height'");
    };
    
    $scope.$on('SQLite:getOfflineDataSuccess', function () {
        //console.log($scope.data);
        $scope.isLoading = false;
        
        $scope.content_data = {
            id: $stateParams.id,
            title: $scope.data.post.title,
            created_date: $scope.data.post.published_date,
            img_src: $scope.data.post.featured_image_path,
            summary: $scope.data.post.summary,
            content: $scope.data.post.content
        };


        if ($scope.content_data.comment_status !== '0') {
            if($scope.content_data.likes !== undefined && $scope.content_data.likes !== null)
            {
                console.log('bisa like');
                if (checkPostLikes($scope.content_data.likes, user_id)) {
                    console.log('pernah like');
                    $scope.liked = true;
                } else {
                    $scope.liked = false;
                }
            }
        }
    });

    $scope.retryLoadContent = function(){
        var url = token_url;
        var obj = serializeData({email: username, password: password, company_id: company_id});
        
        $scope.isTimeout = false;
        
        httpService.post_token($scope, $http, url, obj, 'content');
    };
});