app.controller("TransactionDetailCtrl", function ($scope,
                                                  $cordovaCamera,
                                                  $http,
                                                  httpService,
                                                  $stateParams,
                                                  $ionicLoading,
                                                  $ionicPopup,
                                                  $ionicHistory,
                                                  $ionicPlatform) {

    // loading spinner in the beginning
    $scope.isLoading = true;
    $scope.vt_payment_service = vt_payment_service;
    $scope.rajaongkir_enabled = rajaongkir_enabled;
    $scope.trans_id = -1;
    $scope.custom_transaction_fields = JSON.parse(custom_transaction_fields);
    $scope.default_transaction_fields = JSON.parse(default_transaction_fields)[0];
    
    $scope.tax_enabled = tax_enabled;
    $scope.has_taxes = false;
    $scope.resi_number = '-';
    
    var loadCustomText = function() {
        $scope.button_text_pay_now = "Pay Now";
        $scope.button_text_how_to_pay = "How to Pay";
        $scope.button_text_take_photo = "Take Photo";
        $scope.button_text_choose_photo = "Choose Photo";
        $scope.button_text_track_jne = "Track JNE Status";
        
        $scope.ui_text_transaction_code = "Transaction Code";
        $scope.ui_text_date = "Date";
        $scope.ui_text_status = "Status";
        $scope.ui_text_comments = "Comments";
        $scope.ui_text_admin_notes = "Admin Notes";

        $scope.ui_text_product_name = "Product Name";
        $scope.ui_text_product_price = "Product Price";
        $scope.ui_text_quantity = "Quantity";
        $scope.ui_text_subtotal = "Subtotal";
        
        $scope.ui_text_carrier = "Carrier";
        $scope.ui_text_service = "Service";
        $scope.ui_text_price = "Price";
        
        $scope.ui_text_receipt_save_success = "Your transaction receipt has been saved successfully.";
        $scope.ui_text_receipt_save_failed = "Something wrong when uploading your transaction receipt. Please Try Again";
        
        $scope.subtitle_text_total = "Total";
        $scope.subtitle_text_payment = "Payment";
        $scope.subtitle_text_transaction_receipt = "Transaction Receipt";
        $scope.subtitle_text_transaction_detail = "Transaction Detail";
        $scope.subtitle_text_product_detail = "Product Detail";
        $scope.subtitle_text_delivery_price = "Delivery Price";
        $scope.subtitle_text_taxes = "Taxes";
        
        button_text_pay_now = ui_texts_transactions.button_text_pay_now !== undefined && ui_texts_transactions.button_text_pay_now[language]!==undefined ? ui_texts_transactions.button_text_pay_now[language] : "Pay Now";
        $scope.button_text_pay_now = button_text_pay_now;
        
        button_text_how_to_pay = ui_texts_transactions.button_text_how_to_pay !== undefined && ui_texts_transactions.button_text_how_to_pay[language]!==undefined ? ui_texts_transactions.button_text_how_to_pay[language] : "How to Pay";
        $scope.button_text_how_to_pay = button_text_how_to_pay;
        
        button_text_take_photo = ui_texts_transactions.button_text_take_photo !== undefined && ui_texts_transactions.button_text_take_photo[language]!==undefined ? ui_texts_transactions.button_text_take_photo[language] : "Take Photo";
        $scope.button_text_take_photo = button_text_take_photo;
        
        button_text_choose_photo = ui_texts_transactions.button_text_choose_photo !== undefined && ui_texts_transactions.button_text_choose_photo[language]!==undefined ? ui_texts_transactions.button_text_choose_photo[language] : "Choose Photo";
        $scope.button_text_choose_photo = button_text_choose_photo;
        
        button_text_track_jne = ui_texts_transactions.button_text_track_jne !== undefined && ui_texts_transactions.button_text_track_jne[language]!==undefined ? ui_texts_transactions.button_text_track_jne[language] : "Track JNE Status";
        $scope.button_text_track_jne = button_text_track_jne;
        
        
        ui_text_transaction_code = ui_texts_transactions.ui_text_transaction_code !== undefined && ui_texts_transactions.ui_text_transaction_code[language]!==undefined ? ui_texts_transactions.ui_text_transaction_code[language] : "Transaction Code";
        $scope.ui_text_transaction_code = ui_text_transaction_code;
        
        ui_text_date = ui_texts_transactions.ui_text_date !== undefined && ui_texts_transactions.ui_text_date[language]!==undefined ? ui_texts_transactions.ui_text_date[language] : "Date";
        $scope.ui_text_date = ui_text_date;
        
        ui_text_status = ui_texts_transactions.ui_text_status !== undefined && ui_texts_transactions.ui_text_status[language]!==undefined ? ui_texts_transactions.ui_text_status[language] : "Status";
        $scope.ui_text_status = ui_text_status;
        
        ui_text_comments = ui_texts_transactions.ui_text_comments !== undefined && ui_texts_transactions.ui_text_comments[language]!==undefined ? ui_texts_transactions.ui_text_comments[language] : "Comments";
        $scope.ui_text_comments = ui_text_comments;
        
        ui_text_admin_notes = ui_texts_transactions.ui_text_admin_notes !== undefined && ui_texts_transactions.ui_text_admin_notes[language]!==undefined ? ui_texts_transactions.ui_text_admin_notes[language] : "Admin Notes";
        $scope.ui_text_admin_notes = ui_text_admin_notes;
        
        
        ui_text_product_name = ui_texts_transactions.ui_text_product_name !== undefined && ui_texts_transactions.ui_text_product_name[language]!==undefined ? ui_texts_transactions.ui_text_product_name[language] : "Product Name";
        $scope.ui_text_product_name = ui_text_product_name;
        
        ui_text_product_price = ui_texts_transactions.ui_text_product_price !== undefined && ui_texts_transactions.ui_text_product_price[language]!==undefined ? ui_texts_transactions.ui_text_product_price[language] : "Product Price";
        $scope.ui_text_product_price = ui_text_product_price;
        
        ui_text_quantity = ui_texts_transactions.ui_text_quantity !== undefined && ui_texts_transactions.ui_text_quantity[language]!==undefined ? ui_texts_transactions.ui_text_quantity[language] : "Quantity";
        $scope.ui_text_quantity = ui_text_quantity;
        
        ui_text_subtotal = ui_texts_transactions.ui_text_subtotal !== undefined && ui_texts_transactions.ui_text_subtotal[language]!==undefined ? ui_texts_transactions.ui_text_subtotal[language] : "Subtotal";
        $scope.ui_text_subtotal = ui_text_subtotal;
        
        
        $scope.ui_text_carrier = ui_texts_transactions.ui_text_carrier !== undefined && ui_texts_transactions.ui_text_carrier[language]!==undefined ? ui_texts_transactions.ui_text_carrier[language] : "Carrier";
        
        $scope.ui_text_service = ui_texts_transactions.ui_text_service !== undefined && ui_texts_transactions.ui_text_service[language]!==undefined ? ui_texts_transactions.ui_text_service[language] : "Service";
        
        $scope.ui_text_price = ui_texts_transactions.ui_text_price !== undefined && ui_texts_transactions.ui_text_price[language]!==undefined ? ui_texts_transactions.ui_text_price[language] : "Price";
        
        
        ui_text_receipt_save_success = ui_texts_transactions.ui_text_receipt_save_success !== undefined && ui_texts_transactions.ui_text_receipt_save_success[language]!==undefined ? ui_texts_transactions.ui_text_receipt_save_success[language] : "Your transaction receipt has been saved successfully.";
        $scope.ui_text_receipt_save_success = ui_text_receipt_save_success;
        
        ui_text_receipt_save_failed = ui_texts_transactions.ui_text_receipt_save_failed !== undefined && ui_texts_transactions.ui_text_receipt_save_failed[language]!==undefined ? ui_texts_transactions.ui_text_receipt_save_failed[language] : "Something wrong when uploading your transaction receipt. Please Try Again";
        $scope.ui_text_receipt_save_failed = ui_text_receipt_save_failed;
        
        
        subtitle_text_total = ui_texts_transactions.subtitle_text_total !== undefined && ui_texts_transactions.subtitle_text_total[language]!==undefined ? ui_texts_transactions.subtitle_text_total[language] : "Total";
        $scope.subtitle_text_total = subtitle_text_total;
        
        subtitle_text_payment = ui_texts_transactions.subtitle_text_payment !== undefined && ui_texts_transactions.subtitle_text_payment[language]!==undefined ? ui_texts_transactions.subtitle_text_payment[language] : "Payment";
        $scope.subtitle_text_payment = subtitle_text_payment;
        
        subtitle_text_transaction_receipt = ui_texts_transactions.subtitle_text_transaction_receipt !== undefined && ui_texts_transactions.subtitle_text_transaction_receipt[language]!==undefined ? ui_texts_transactions.subtitle_text_transaction_receipt[language] : "Transaction Receipt";
        $scope.subtitle_text_transaction_receipt = subtitle_text_transaction_receipt;
        
        subtitle_text_transaction_detail = ui_texts_transactions.subtitle_text_transaction_detail !== undefined && ui_texts_transactions.subtitle_text_transaction_detail[language]!==undefined ? ui_texts_transactions.subtitle_text_transaction_detail[language] : "Transaction Detail";
        $scope.subtitle_text_transaction_detail = subtitle_text_transaction_detail;
        
        subtitle_text_product_detail = ui_texts_transactions.subtitle_text_product_detail !== undefined && ui_texts_transactions.subtitle_text_product_detail[language]!==undefined ? ui_texts_transactions.subtitle_text_product_detail[language] : "Product Detail";
        $scope.subtitle_text_product_detail = subtitle_text_product_detail;
        
        $scope.subtitle_text_delivery_price = ui_texts_transactions.subtitle_text_delivery_price !== undefined && ui_texts_transactions.subtitle_text_delivery_price[language]!==undefined ? ui_texts_transactions.subtitle_text_delivery_price[language] : "Delivery Price";
        
        $scope.subtitle_text_taxes = ui_texts_transactions.subtitle_text_taxes !== undefined && ui_texts_transactions.subtitle_text_taxes[language]!==undefined ? ui_texts_transactions.subtitle_text_taxes[language] : $scope.subtitle_text_taxes;
    }
    
    loadCustomText();

    $ionicPlatform.ready(function () {

        // check user login
        if (user_id === '') {
            $scope.isLogin = false;
        } else {
            $scope.isLogin = true;
        }
        $scope.isTimeout = false;

        var url = token_url;
        var obj = serializeData({email: username, password: password, company_id: company_id});
        httpService.post_token($scope, $http, url, obj);
        $scope.currency = currency;

    });

    $scope.makePayment = function () {
        // TODO: Open InAppBrowser to this link: $scope.content_data.payment_url
        openBrowser($scope.content_data.payment_url);
    };

    $scope.trackJNEStatus = function () {
        //TODO: perlu request ke api ga tiap pencet? ato langsung pas masuk detail di kasi datanya?
        $scope.showJNEAlert();
    };

    $scope.trackSicepatStatus = function (resi_number) {
        $scope.show();
        if(resi_number == null)
        {
            $scope.showSicepatAlert(false, false);
        }
        else 
        {
            $scope.resi_number = resi_number;
            var url = sicepat_track_waybill + resi_number;
            httpService.get($scope, $http, url, 'sicepat-track-status');
        }
    }

    $scope.showJNEAlert = function () {
        var alertPopup = $ionicPopup.alert({
            title: 'JNE Status',
            template: '<div style="width:100%;text-align:center">Your Tracking Status is: ON PROCESS</div>',
            buttons: [
                {
                    text: 'OK',
                    type: 'cp-button'
                }
            ]
        });
    };

    $scope.showSicepatAlert = function (valid, result) {
        console.log(valid);
        console.log(result);
        if(valid == "success")
        {
            var alertPopup = $ionicPopup.alert({
                title: 'Sicepat Resi Status',
                template: '<div style="width:100%;text-align:center">Your Tracking Status: ' + result.last_status.status + '<br>Receiver Name: '+ result.receiver_name +' </div>',
                buttons: [
                    {
                        text: 'OK',
                        type: 'cp-button'
                    }
                ]
            });
        }
        else if(!valid)
        {
            var alertPopup = $ionicPopup.alert({
                title: 'Sicepat Resi Status',
                template: '<div style="width:100%;text-align:center">Invalid Resi Number.</div>',
                buttons: [
                    {
                        text: 'OK',
                        type: 'cp-button'
                    }
                ]
            });
        }
        else if(valid == "error")
        {
            var alertPopup = $ionicPopup.alert({
                title: 'Sicepat Resi Status',
                template: '<div style="width:100%;text-align:center">There is a problem with your Resi Number or Internet Connection. Please try again.</div>',
                buttons: [
                    {
                        text: 'OK'
                    },
                    {
                        text: 'Try Again',
                        type: 'cp-button',
                        onTap: function(){
                            $scope.show();
                            var url = sicepat_track_waybill + $scope.resi_number;
                            httpService.get($scope, $http, url, 'sicepat-track-status');
                        }
                    }
                ]
            });
        }
        $scope.hide();
    };

    $scope.$on('httpService:getSicepatTrackStatusSuccess', function () {
        $scope.hide();
        $scope.sicepat = $scope.data.sicepat;
        if(typeof $scope.sicepat.status.code !== 'undefined' && $scope.sicepat.status.code == 200)
        {
            $scope.showSicepatAlert("success", $scope.sicepat.result);
        }
        else if(typeof $scope.sicepat.status.code == 'undefined')
        {
            $scope.showSicepatAlert("error", false);
        }
        else
        {
            $scope.showSicepatAlert(false, false);
        }
    });

    $scope.$on('httpService:getSicepatTrackStatusError', function () {
        $scope.hide();
        $scope.showSicepatAlert("error", false);
    });

    // get token for getting detail data success
    $scope.$on('httpService:postTokenSuccess', function () {
        token = $scope.data.token;
        //console.log(token);
        var url = user_transaction_detail + $stateParams.id;
        httpService.get($scope, $http, url, 'content', token);
        console.log('TransactionDetailCtrl');

    });

    // get data success
    $scope.$on('httpService:getRequestSuccess', function () {
//        $scope.data.taxes_data = '[{"label":"Tax (10%)","value":100},{"label":"test","value":"1000"},{"label":"Tax 2","value":525},{"label":"Tax 3","value":525},{"label":"Tax 4","value":1575}]';
        $scope.parsed_taxes_data = JSON.parse($scope.data.taxes_data);
        $scope.has_taxes = $scope.parsed_taxes_data.length > 0? true : false;
        console.log($scope.parsed_taxes_data.length);
        console.log($scope.has_taxes);
        console.log($scope.tax_enabled);
        $scope.content_data = {
            id: $stateParams.id,
            trans_master: $scope.data.trans_master,
            trans_details: $scope.data.trans_details,
            payment_url: $scope.data.payment_url,
            trans_meta: $scope.data.trans_meta,
            delivery_data: $scope.data.delivery_data,
            taxes_data: $scope.parsed_taxes_data
        };

        $scope.imgURI = $scope.content_data.trans_master.transfer_receipt;
        if(($scope.imgURI==undefined || $scope.imgURI == '') &&  vt_payment_service === 'NO')
        {
            $scope.uploadPhotoReminder();
        }

        $scope.isLoading = false;
        // if(isPhoneGap())
        // {
        //     //console.log($stateParams.id + " " + $scope.data.post.term_id + " " + 'TransactionDetailCtrl' + " " + $scope.data);
        //     savePostJSONToDB($stateParams.id, user_id, 'TransactionDetailCtrl', $scope.data);
        //     //console.log('saved');
        // }

    });

    // if get token detail data Error, request token again
    $scope.$on('httpService:postTokenError', function () {
        if ($scope.status === 0) {
            // if(isPhoneGap())
            // {
            //     loadPostJSONFromDB($stateParams.id, $scope);
            // }
        }
        else {
            var url = token_url;
            var obj = serializeData({email: username, password: password, company_id: company_id});
            httpService.post_token($scope, $http, url, obj, 'content');
        }
    });

    // if get detail data Error, request token again
    $scope.$on('httpService:getRequestError', function () {
        // var url = token_url;
        // var obj = serializeData({email: username, password: password, company_id: company_id});
        $scope.isTimeout = true;
        // httpService.post_token($scope, $http, url, obj, 'content');

    });

    // loading fragment
    $scope.show = function () {
        $ionicLoading.show({
            template: ionicLoadingTemplate
        });
    };
    $scope.hide = function () {
        $ionicLoading.hide();
    };

    $scope.isPhoneGap = function () {
        return isPhoneGap();
    };

    // $scope.$on('SQLite:getOfflineDataSuccess', function () {
    //     //console.log($scope.data);
    //     $scope.isLoading = false;
    //
    //     $scope.content_data = {
    //         id: $stateParams.id,
    //         trans_master: $scope.data.trans_master,
    //         trans_details: $scope.data.trans_details
    //     };
    //
    // });

    $scope.retryLoadContent = function () {
        var url = token_url;
        var obj = serializeData({email: username, password: password, company_id: company_id});

        $scope.isTimeout = false;

        httpService.post_token($scope, $http, url, obj, 'content');
    };

    function openBrowser(url) {
        if (!isPhoneGap()) {
            window.open(url, '_blank', 'location=yes');
        }
        else {
            cordova.ThemeableBrowser.open(url, '_blank', {
                statusbar: {
                    color: '#ffffffff'
                },
                toolbar: {
                    height: 44,
                    color: '#ffffffff'
                },
                title: {
                    color: '#212121ff',
                    showPageTitle: true
                },
                backButton: {
                    wwwImage: 'images/drawable-xhdpi/back.png',
                    wwwImagePressed: 'images/drawable-xhdpi/back_pressed.png',
                    wwwImageDensity: 2,
                    align: 'left',
                    event: 'backPressed'
                },
                forwardButton: {
                    wwwImage: 'images/drawable-xhdpi/forward.png',
                    wwwImagePressed: 'images/drawable-xhdpi/forward_pressed.png',
                    wwwImageDensity: 2,
                    align: 'left',
                    event: 'forwardPressed'
                },
                closeButton: {
                    wwwImage: 'images/drawable-xhdpi/close.png',
                    wwwImagePressed: 'images/drawable-xhdpi/close_pressed.png',
                    wwwImageDensity: 2,
                    align: 'right',
                    event: 'closePressed'
                },
                backButtonCanClose: true
            });
        }
    }

    $scope.takePhoto = function (trans_id) {
        $scope.trans_id = trans_id;
        if (!isPhoneGap()) {
            console.log("Not in a mobile device");
            return;
        }
        var options = {
            quality: 75,
            destinationType: Camera.DestinationType.DATA_URL,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: true,
            encodingType: Camera.EncodingType.JPEG,
            targetWidth: 300,
            targetHeight: 300,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            $scope.imgURI = "data:image/jpeg;base64," + imageData;

            var obj = serializeData({_method: 'POST', transfer_receipt: $scope.imgURI});
            $scope.result = httpService.post($scope, $http, update_transfer_receipt + $scope.trans_id, obj, 'update_transfer_receipt');
            $scope.show();
        }, function (err) {
            if(err == "Selection cancelled.") {
                //do Nothing
            }
            else if(err == "Camera cancelled.") {
                // do Nothing
            }
            else {
                $scope.hide();
                $scope.uploadPhotoFailed();
            }
        });
    };

    $scope.choosePhoto = function (trans_id) {
        $scope.trans_id = trans_id;
        if (!isPhoneGap()) {
            console.log("Not in a mobile device");
            return;
        }
        var options = {
            quality: 75,
            destinationType: Camera.DestinationType.DATA_URL,
            sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
            allowEdit: true,
            encodingType: Camera.EncodingType.JPEG,
            targetWidth: 300,
            targetHeight: 300,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            $scope.imgURI = "data:image/jpeg;base64," + imageData;

            var obj = serializeData({_method: 'POST', transfer_receipt: $scope.imgURI});
            $scope.result = httpService.post($scope, $http, update_transfer_receipt + $scope.trans_id, obj, 'update_transfer_receipt');
            $scope.show();
        }, function (err) {
            if(err == "Selection cancelled.") {
                //do Nothing
            }
            else if(err == "Camera cancelled.") {
                // do Nothing
            }
            else {
                $scope.hide();
                $scope.uploadPhotoFailed();
            }
        });
    };
    
    $scope.uploadPhotoReminder = function () {
        var alertPopup = $ionicPopup.alert({
            title: 'Transaction Receipt',
            template: '<div style="width:100%;text-align:center">Please upload the receipt by one of the options below</div>',
            cssClass: 'popup-vertical-buttons',
            buttons: [
                {
                    text: $scope.button_text_choose_photo,
                    type: 'cp-button button-block',
                    onTap: function (e) {
                        $scope.takePhoto($scope.content_data.trans_master.id);
                    }
                },
                {
                    text: $scope.button_text_take_photo,
                    type: 'cp-button button-block',
                    onTap: function (e) {
                        $scope.choosePhoto($scope.content_data.trans_master.id);
                    }

                },
                {
                    text: 'OK',
                    type: 'cp-button button-block'
                }
            ]
        });
    };
    
    $scope.uploadPhotoSuccess = function () {
        var alertPopup = $ionicPopup.alert({
            title: 'Transaction Receipt',
            template: '<div style="width:100%;text-align:center">'+$scope.ui_text_receipt_save_success+'</div>',
            buttons: [
                {
                    text: 'OK',
                    type: 'cp-button'
                }
            ]
        });
    };

    $scope.uploadPhotoFailed = function () {
        var alertPopup = $ionicPopup.alert({
            title: 'Transaction Receipt',
            template: '<div style="width:100%;text-align:center">'+$scope.ui_text_receipt_save_failed+'</div>',
            buttons: [
                {
                    text: 'Try Again',
                    type: 'cp-button'
                    // onTap: function(e) {
                    //     $scope.choosePhoto($scope.trans_id);
                    // }
                }
            ]
        });
    };

    $scope.show = function () {
        $ionicLoading.show({
            template: ionicLoadingTemplate
        });
    };
    $scope.hide = function () {
        $ionicLoading.hide();
    };

    $scope.$on('httpService:postUpdateTransferReceiptError', function () {
        $scope.hide();
        $scope.uploadPhotoFailed();
    });

    $scope.$on('httpService:postUpdateTransferReceiptSuccess', function () {
        $scope.hide();
        $scope.uploadPhotoSuccess();
    });
});
